//+--------------------------------------------------------------------------+
//|                                                2 MA Cross with alert.mq4 |
//|                                                                   mladen |
//+--------------------------------------------------------------------------+

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 SkyBlue
#property indicator_color2 DarkOrange
#property indicator_color5 Lime
#property indicator_color6 Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width5 2
#property indicator_width6 2

//
//
//
//
//
extern string hlcj             = "HighLow channel smooth daily for trend";
extern int    SmoothPeriod     = 10;
extern int    SmoothPhase      =  0;

extern string ex6              = "Show JMa Lines";  
extern bool   showJMAs          = false;

extern string ex6a             = "Show JMa Lines without arrows";  
extern bool   showJMAsnoarrows = false;

extern string ex7              = "Alerts";
extern bool   crossesOnCurrent = true;
extern bool   alertsOn         = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;

extern string note7            = "Arrow Type";
extern string note8            = "0=Thick, 1=Thin, 2=Hollow, 3=Round";
extern string note9            = "4=Fractal, 5=Diagonal Thin";
extern string note10           = "6=Diagonal Thick, 7=Diagonal Hollow";
extern string note11           = "8=Thumb, 9=Finger";
extern int    ArrowType        = 1;

extern string note_TimeFrames_ = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-currentTF";
extern int    timeFrame        = 0;
extern bool   Interpolate      = true;



//
//
//
//
//
int    TimeFrame;
double CrossUp[];
double CrossDown[];
double ma1[];
double ma2[];
double ma1s[];
double ma2s[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if (ArrowType == 0) {
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 233);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 234);
   }
   else if (ArrowType == 1) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 225);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 226);
   }
   else if (ArrowType == 2) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 241);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 242);
   }
   else if (ArrowType == 3) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 221);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 222);
   }
   else if (ArrowType == 4) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 217);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 218);
   }
   else if (ArrowType == 5) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 228);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 230);
   }
   else if (ArrowType == 6) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 236);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 238);
   }
   else if (ArrowType == 7) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 246);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 248);
   }
   else if (ArrowType == 8) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 67);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 68);
   }
   else if (ArrowType == 9) { 
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 71);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 72);
   }
   
   SetIndexBuffer(2,ma1);
   SetIndexBuffer(3,ma2);
   SetIndexBuffer(4,ma1s);
   SetIndexBuffer(5,ma2s);
   
   if (showJMAs)
   {
      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_LINE);
      SetIndexStyle(5,DRAW_LINE);
      SetIndexEmptyValue(2,0.00);
      SetIndexEmptyValue(3,0.00);
      SetIndexEmptyValue(4,0.00);
      SetIndexEmptyValue(5,0.00);
   }  
   else if (showJMAsnoarrows)
   {
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_LINE);
      SetIndexStyle(5,DRAW_LINE);
      SetIndexEmptyValue(2,0.00);
      SetIndexEmptyValue(3,0.00);
      SetIndexEmptyValue(4,0.00);
      SetIndexEmptyValue(5,0.00);
   }          
   else
   {
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
   }      

   SetIndexLabel(0,"maCrossUp");
   SetIndexLabel(1,"maCrossDn");
   
   TimeFrame = stringToTimeFrame(timeFrame);
   
   string TimeFrameStr;
   switch(TimeFrame)
   {
      case PERIOD_M1:  TimeFrameStr="(M1)";      break;
      case PERIOD_M5:  TimeFrameStr="(M5)";      break;
      case PERIOD_M15: TimeFrameStr="(M15)";     break;
      case PERIOD_M30: TimeFrameStr="(M30)";     break;
      case PERIOD_H1:  TimeFrameStr="(H1)";      break;
      case PERIOD_H4:  TimeFrameStr="(H4)";      break;
      case PERIOD_D1:  TimeFrameStr="(Dayly)";   break;
      case PERIOD_W1:  TimeFrameStr="(Weekly)";  break;
      case PERIOD_MN1: TimeFrameStr="(Monthly)"; break;
      default :        TimeFrameStr="";
   }   
   IndicatorShortName("Jurik Hi Lo Cross Alerta Mtf("+TimeFrameStr+")");

   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{ 
   int    limit, i; 
   int    counted_bars=IndicatorCounted();
   double fasterMAnow, fasterMAprevious;
   double slowerMAnow, slowerMAprevious;
   
   

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (TimeFrame > Period()) limit = MathMax(limit,TimeFrame/Period());





   //
   //
   //
   //
   //
   //

   
      for(i = limit; i >= 0; i--)
	   {
		int      shift1 = iBarShift(NULL,TimeFrame,Time[i]);
		datetime time1  = iTime    (NULL,TimeFrame,shift1);
		
      CrossUp[i]   = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,0,shift1);
      CrossDown[i] = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,1,shift1);   
      ma1[i]       = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,2,shift1);
      ma2[i]       = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,3,shift1);
      ma1s[i]      = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,4,shift1);
      ma2s[i]      = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,5,shift1);
      
      if(TimeFrame <= Period() || shift1==iBarShift(NULL,TimeFrame,Time[i-1])) continue;
      if (!Interpolate) continue;
         
		 
  		for(int n = 1; i+n < Bars && Time[i+n] >= time1; n++) continue;	

  		 double factor = 1.0 / n;
       for(int k = 1; k < n; k++)
		  {
		  CrossUp[i+k]  = k*factor*CrossUp[i+n]  + (1.0-k*factor)*CrossUp[i];
		  CrossDown[i+k]= k*factor*CrossDown[i+n]+ (1.0-k*factor)*CrossDown[i];
		  ma1[i+k]      = k*factor*ma1[i+n]      + (1.0-k*factor)*ma1[i];
		  ma2[i+k]      = k*factor*ma2[i+n]      + (1.0-k*factor)*ma2[i];
		  ma1s[i+k]     = k*factor*ma1s[i+n]     + (1.0-k*factor)*ma1s[i];
		  ma2s[i+k]     = k*factor*ma2s[i+n]     + (1.0-k*factor)*ma2s[i];				
		  }
		  }
		  for(i = limit; i >= 0; i--)
	      { 
	      ma1[i]  = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,1,i);
         ma2[i]  = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,0,i);
         ma1s[i] = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,1,i);
         ma2s[i] = iCustom(NULL,TimeFrame,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,0,i);
     
         if (crossesOnCurrent==false && i==0) continue;
         
      //
      //
      //
      //
      //
         
         fasterMAnow      = ma1[i];
         fasterMAprevious = ma1[i+1];
         slowerMAnow      = ma2[i];
         slowerMAprevious = ma2[i+1];
      
      //
      //
      //
      //
      //
      
      int    crossID=0;
      double curr;
      double prev;
      double point;
      while (true)
         {
            if (fasterMAnow > 0 && slowerMAnow > 0)
               {
                  curr  =  fasterMAnow      - slowerMAnow;
                  prev  =  fasterMAprevious - slowerMAprevious;
                  point = (fasterMAnow      + fasterMAprevious)/2;
                     if (curr*prev<=0) { crossID=2; break; }
               }
               break;
         }
      
         //
         //
         //
         //
         //
         
         CrossUp[i]    = EMPTY_VALUE;
         CrossDown[i]  = EMPTY_VALUE;
         if (crossID>0)
         {
            if (alertsOn)
            if ((i==0 && crossesOnCurrent==true) || (i==1 && crossesOnCurrent==false))
            {
                        if(curr>0) doAlert("Fast JMA crossed Slow JMA UP");
                        else       doAlert("Fast JMA crossed Slow JMA DOWN"); 
             
            }               

            //
            //
            //
            //
            //
            
            double Range = 0.0;
            for (int counter=i ;counter<=i+9;counter++) Range += MathAbs(High[counter]-Low[counter]);
                                                        Range /= 10;

            //
            //
            //
            //
            //
            



               if (curr>0)    {
                     CrossUp[i]   = point - Range*0.85;
                                    }
               else           {
                     CrossDown[i] = point + Range*0.85;             
                                    }

         }               

   }   
   return(0);
 }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
 
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"JMA line crossing"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int tchar = StringGetChar(tfs,l);
          if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
               tfs = StringSetChar(tfs, l, tchar - 32);
          else 
              if(tchar > -33 && tchar < 0)
                  tfs = StringSetChar(tfs, l, tchar + 224);
   }

   //
   //
   //
   //
   //
   
   int tf=0;
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
   return(tf);
}


